package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallLogisticsCompanyApplicationService;
import com.jeesharp.business.modules.mall.dto.MallLogisticsCompanySaveDTO;
import com.jeesharp.business.modules.mall.entity.MallLogisticsCompany;
import com.jeesharp.business.modules.mall.vo.MallLogisticsCompanyInfoVO;
import com.jeesharp.business.modules.mall.vo.MallLogisticsCompanyListVO;
import com.jeesharp.business.modules.mall.vo.MallLogisticsCompanyQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;
import java.util.List;

/**
 * 物流公司管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/logisticsCompany/v1")
@Tag(name = "物流公司管理")
@AllArgsConstructor
public class MallLogisticsCompanyController extends BaseController {

    private final MallLogisticsCompanyApplicationService mallLogisticsCompanyApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallLogisticsCompanyInfoVO> info(@RequestParam("id") String id) {
        MallLogisticsCompanyInfoVO vo = mallLogisticsCompanyApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallLogisticsCompanyListVO>> list(@RequestBody MallLogisticsCompanyQueryVO query) {
        PageRespVO<MallLogisticsCompanyListVO> page = mallLogisticsCompanyApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallLogisticsCompanySaveDTO dto) {
        mallLogisticsCompanyApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallLogisticsCompanyApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }

    @Operation(summary = "获取启用的物流公司")
    @GetMapping(value = "getEnabled")
    public AjaxResult<List<MallLogisticsCompany>> getEnabled() {
        List<MallLogisticsCompany> companies = mallLogisticsCompanyApplicationService.listEnabledCompanies();
        return AjaxResult.okData(companies);
    }
}
